<template>
    <main v-if="init" class="dashboard">
        <new-group v-if="showGroupModal"></new-group>
        <new-playlist v-if="showPlaylistModal"></new-playlist>
        <div class="wrapper">
            <section>
                <h2>Rooms</h2>
                <div class="room-cards">
                    <div v-for="room in rooms">
                        <div @click="changeRoomPlayerID(room.idRoom)">
                            <Card :id="room.idRoom" type="room" image_url="" nowPlaying="Red Hot Chilli Peppers - By The Way"
                                  :title="room.name"></Card>
                        </div>
                    </div>
                    <div>
                        <button v-on:click="openGroupModal" class="btn card add-room">
                            <img src="../../assets/icons/add.svg">
                            <span class="add-button-text">Add Room</span>
                        </button>
                    </div>
                </div>
            </section>
            <section>
                <h2>Playlists</h2>

                <div class="playlist-cards">
                    <div v-for="playlist in playlists">

                        <router-link :to="{name: 'playlist', params : {id_playlist: 2}}">
                            <Card :id="playlist.idPlaylist" type="playlist" image_url="https://loremflickr.com/290/290/music" now-playing=""
                                  :title="playlist.name"></Card>
                        </router-link>
                    </div>
                    <div>
                        <button v-on:click="openPlaylistModal" class="btn card add-playlist"><img
                                src="../../assets/icons/add.svg"> <span class="add-button-text">Add Playlist</span>
                        </button>
                    </div>
                </div>
            </section>
        </div>
    </main>

</template>

<script>
    import Card from '../presentational/card'
    import NewGroup from '../group/new-group'
    import NewPlaylist from '../playlist/new-playlist'
    import WS from '../../websocket_con'
    import { store, mutations } from '../../store'

    export default {
        name: 'Dashboard',
        data() {
            return {
                init: true,
                showGroupModal: false,
                showPlaylistModal: false,
                preventLink: false,
                //playlists: [],
                //rooms: []
            }
        },
        computed: {
            rooms() {
                return store.rooms;
            },
            playlists() {
                return store.playlists;
            }
        },
        created() {
            WS.send(JSON.stringify({apiToken: localStorage.token, action: 'getRooms'}));
            WS.send(JSON.stringify({apiToken: localStorage.token, action: 'getPlaylists'}));
        },

        components: {
            Card,
            NewGroup,
            NewPlaylist
        },
        methods: {
            openGroupModal: function () {
                this.showGroupModal = true;
            },

            closeGroupModal: function () {
                this.showGroupModal = false;
            },

            openPlaylistModal: function () {
                this.showPlaylistModal = true;
            },

            closePlaylistModal: function () {
                this.showPlaylistModal = false;
            },

            deleteRoom: function (id_room) {
                WS.send(JSON.stringify({apiToken: localStorage.token, action: 'deleteRoom', idRoom: id_room}));
            },

            deletePlaylist: function (id_playlist) {
                WS.send(JSON.stringify({apiToken: localStorage.token, action: 'deletePlaylist', idPlaylist: id_playlist}));
            },

            changeRoomPlayerID: function (id_room){
                WS.send(JSON.stringify({apiToken: localStorage.token, action: 'joinRoom', idRoom: id_room}));
                this.$router.push('player')
            }
        },
    }

</script>
<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped lang="scss">
    @import "../../assets/theme";

    .wrapper {
        display: flex;
        flex-direction: row;
        justify-content: space-between;
    }

    .card {
        position: absolute;
        top: 0;
        left: 0;
        bottom: 0;
        right: 0;
    }

    section {
        margin: 0 20px 0 20px;
        width: calc(50% - 20px);

        .room-cards, .playlist-cards {
            display: grid;
            grid-template-columns: 1fr 1fr;
            grid-column-gap: 20px;
            grid-row-gap: 20px;

            > div {
                width: 100%;
                padding-top: 100%;
                position: relative;
            }
        }
    }

    button.add-room, button.add-playlist {
        background-color: $PRIMARY-COLOUR;
        color: transparent;
        padding: 40px;
        width: 100%;
        height: 100%;
        position: absolute;


        &:hover {
            color: $WHITE;

            span {
                background-color: rgba(39, 41, 66, 0.95);
            }
        }

        span {
            position: absolute;
            top: 0;
            left: 0;
            width: 100%;
            height: 100%;
            background-color: rgba(39, 41, 66, 0);
            padding-top: calc(50% - 10px);
            box-sizing: border-box;
        }

    }
</style>
